
#ifndef __bp_ensemble_h
#define __bp_ensemble_h

extern void	setEnsembleError	ARGS((Group	group)) ;
extern void	setEnsembleTransfer	ARGS((Group	group)) ;
extern void	setEnsembleCombIn	ARGS((Group	group)) ;

typedef struct LinkExtensionRec { /* BIND */
  Real		cost ;
  Variable 	variance ;
} 
LinkExtensionRec ;

#define MlinkVariance(link)    ((link)->extension->variance)

#define MgetWeight(l)			variableGetValue  (l)
#define MsetWeightDeriv(l,x)		variableSetDeriv  (l,x)
#define MaddToWeightDeriv(l,x)		variableAddToDeriv(l,x)

#define MgetWeightVar(l)		variableGetValue  (MlinkVariance(l))
#define MsetWeightVarDeriv(l,x)		variableSetDeriv  (MlinkVariance(l),x)
#define MaddToWeightVarDeriv(l,x)	variableAddToDeriv(MlinkVariance(l),x)

#define MgetLinkCost(l)			((l)->extension->cost)
#define MsetLinkCost(l,c)		(((l)->extension->cost) = (c))

extern String	*unitFields () ;
extern Real	unitValue	ARGS((Unit, int, int)) ;
extern void	setUnitValue	ARGS((Unit, int, int, double)) ;

extern String	*linkFields () ;
extern Real	linkValue	ARGS((Link, int)) ;
extern void	setLinkValue	ARGS((Link, int, double)) ;

#endif				/* __bp_ensemble_h */
